Mini-NDN
========

### What is Mini-NDN?

Mini-NDN is a lightweight networking emulation tool that enables testing, experimentation, and
research on the NDN platform. Based on [Mini-CCNx](https://github.com/chesteve/mn-ccnx) which
is a fork of [Mininet](https://github.com/mininet/mininet), Mini-NDN uses the NDN libraries,
NFD, NLSR, and tools released by the [NDN project](http://named-data.net/codebase/platform/)
to emulate an NDN network on a single system.

Mini-NDN is open and free software licensed under the GPL 3.0 license. Mini-NDN is free to all
users and developers. For more information about licensing details and limitations,
please refer to [COPYING.md](COPYING.md).

The first release of Mini-NDN is developed by members of the NSF-sponsored NDN project team.
Mini-NDN is open to contribution from the public.
For more details, please refer to [AUTHORS.md](AUTHORS.md).
Bug reports and feedback are highly appreciated and can be made through our
[Redmine site](http://redmine.named-data.net/projects/mini-ndn) and the
[mini-ndn mailing list](http://www.lists.cs.ucla.edu/mailman/listinfo/mini-ndn).

### Documentation

* [Installation](INSTALL.md)
* [Getting Started](docs/GETTING-STARTED.md)
* [Mini-NDN Edit](docs/GUI.md)
* [Running Experiments](docs/EXPERIMENTS.md)
* [Mini-NDN Redmine](http://redmine.named-data.net/projects/mini-ndn)
