#!/usr/bin/python

import time
from ndn.experiments.experiment import Experiment

class NleTest(Experiment):

    def __init__(self, args):
        Experiment.__init__(self, args)

    def setup(self):
       for host in self.net.hosts:
                for intf in host.intfNames():
        	        ndnDumpOutputFile = "dump.%s_%s" % (intf, str(host.intf(intf).IP()))
	                host.cmd("sudo ndndump -f '.*nle.*' -i %s > %s &" % (intf, ndnDumpOutputFile))
		if host.name == 'ca':
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.2")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/multicast")
			print("ca done")
		elif host.name == 'ga':
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.6")
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.10")
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.14")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/best-route")
			#host.cmd("ifconfig -a | sed 's/[ \t].*//;/^\(lo\|\)$/d' > /tmp/ga/test.txt")
			#print("ga done1")
			#for line in open('/tmp/ga/test.txt', 'r'):
			#	line=line.rstrip('\n')
			#	host.cmd("NetStat.sh -i %s &" % line)
			#host.cmd("delayface1.sh &")
			#host.cmd("delayface2.sh &")
			#host.cmd("delayface3.sh &")
			#host.cmd("delayface4.sh &")
			print("ga done")
		elif host.name == 'ha':
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.18")
			print("h1 done")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/multicast")
		elif host.name == 'hb':
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.22")
			#host.cmd("nfdc register /ndn/nle udp4://1.0.0.28")
			print("h2 done")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/multicast")
		elif host.name == 'hc':
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.26")
			#host.cmd("nfdc register /ndn/nle udp4://1.0.0.30")
			print("h3 done")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/multicast")
		elif host.name == 'ta':
			host.cmd("nfdc register /ndn/nle udp4://1.0.0.30")
			print("ta done")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/multicast")

				
    def run(self):
       for host in self.net.hosts:
		if host.name == 'ga':
			#host.cmd("nfdc register /ndn/nle udp4://1.0.0.6")
			#host.cmd("nfdc register /ndn/nle udp4://1.0.0.10")
			#host.cmd("nfdc register /ndn/nle udp4://1.0.0.14")
			host.cmd("nfdc set-strategy /ndn/nle ndn:/localhost/nfd/strategy/best-route")
			print("ga Done")
		elif host.name == 'sa':
			host.cmd("ndn-traffic-server -c 200000 /home/ashu/Desktop/ndn-src/ndn-traffic-generator/ndn-traffic-server.conf 2&> traffic-server-logs &")
			print("sa done")

		#elif host.name == 'sb':
			#host.cmd("ndn-traffic-server -c 200000 /home/mininet/mini-ndn/ndn-traffic-generator/build/ndn-traffic-server2.conf &")
			#print("sa done")

		# elif host.name == 'hb':
			# host.cmd("ndn-traffic-server /home/mininet/mini-ndn/ndn-traffic-generator/build/ndn-traffic-server3.conf &")			
			# print("sb done")
		# elif host.name == 'hc':
			# #host.cmd("nfdc register /ndn/nle udp4://1.0.0.26")
			# host.cmd("ndn-traffic-server /home/mininet/mini-ndn/ndn-traffic-generator/build/ndn-traffic-server2.conf &")
			# print("sc done")
		# elif host.name == 'hd':
			# host.cmd("ndn-traffic-server /home/mininet/mini-ndn/ndn-traffic-generator/build/ndn-traffic-server4.conf &")
			# print("sd done")


Experiment.register("icnle", NleTest)
